; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;			(adr_GRAFIC_X1_L)													
;			(adr_GRAFIC_X1_H)													
;			(adr_GRAFIC_Y2_L)													
;			(adr_GRAFIC_Y2_H)													
;																				
;																				
; Zeichnet eine LINIE an den KOORDINATEN (X1,Y1) (X2,Y2)						
;																				
GRAFIC_LINIE:
;-------------------------------------------------------------------------------
; ANFANGS und Endpunkte setzen													
	LDS temp1,(adr_GRAFIC_X1_L)		; X1 temp1+2	
	LDS temp2,(adr_GRAFIC_X1_H)
	LDS temp3,(adr_GRAFIC_Y1_L)		; Y1 temp3+4	
	LDS temp4,(adr_GRAFIC_Y1_H)
	mov XL,temp1
	mov XH,temp2
	mov YL,temp3
	mov YH,temp4
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
;rcall wait_100ms
	LDS temp5,(adr_GRAFIC_X2_L)		; X2 temp5+6	
	LDS temp6,(adr_GRAFIC_X2_H)
	LDS temp7,(adr_GRAFIC_Y2_L)		; Y2 temp7+8	
	LDS temp8,(adr_GRAFIC_Y2_H)
	mov XL,temp5
	mov XH,temp6
	mov YL,temp7
	mov YH,temp8
	rcall GRAFIC_PUNKT_X_Y			; PUNKT			
	WDR
;rcall wait_100ms
;-------------------------------------------------------------------------------
;	ANFANG und ENDE gleich X=Y ?												
	cp temp1,temp5	; X1 X2 (LOW)	
	brne GRAFIC_LINIE_NO_GLEICH
	cp temp3,temp7	; Y1 Y2 (LOW)	
	brne GRAFIC_LINIE_NO_GLEICH
	cp temp2,temp6	; X1 X2 (HIGH)	
	brne GRAFIC_LINIE_NO_GLEICH
	cp temp4,temp8	; Y1 Y2 (HIGH)	
	brne GRAFIC_LINIE_NO_GLEICH
	ret
GRAFIC_LINIE_NO_GLEICH:
;-------------------------------------------------------------------------------
; Horizontale linie, Y1=Y2 ?													
	cp temp3,temp7	; Y1 Y2 (LOW)	
	brne GRAFIC_LINIE_NO_HORIZONTAL
	cp temp4,temp8	; Y1 Y2 (HIGH	
	brne GRAFIC_LINIE_NO_HORIZONTAL
	; X2-X1 negativ ?			
	sub temp5,temp1
	sbc temp6,temp2
	tst temp6
	brpl GRAFIC_LINIE_HORIZONTAL_p	; positv	
	; negativ X1+X2 tauschen	
	LDS XL,(adr_GRAFIC_X2_L)		; X2	
	LDS XH,(adr_GRAFIC_X2_H)
	LDS ZL,(adr_GRAFIC_X1_L)		; X1 Schleife
	LDS ZH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y1_L)		; Y1 	
	LDS YH,(adr_GRAFIC_Y1_H)
	rjmp GRAFIC_LINIE_HORIZONTAL_s
GRAFIC_LINIE_HORIZONTAL_p:
	; positiv					
	LDS XL,(adr_GRAFIC_X1_L)		; X1
	LDS XH,(adr_GRAFIC_X1_H)
	LDS ZL,(adr_GRAFIC_X2_L)		; X2 Schleife
	LDS ZH,(adr_GRAFIC_X2_H)
	LDS YL,(adr_GRAFIC_Y1_L)		; Y1 	
	LDS YH,(adr_GRAFIC_Y1_H)
	; SCHLEIFE					
GRAFIC_LINIE_HORIZONTAL_s:
	adiw XL,1
	rcall GRAFIC_PUNKT_X_Y	; PUNKT	
	cp XL,ZL ;Schleife
	brne GRAFIC_LINIE_HORIZONTAL_s
	cp XH,ZH ;Schleife
	brne GRAFIC_LINIE_HORIZONTAL_s
	ret
GRAFIC_LINIE_NO_HORIZONTAL:
;-------------------------------------------------------------------------------
; Vertikale LINIE X1=X2															
	cp temp1,temp5	; X1 X2 (LOW)	
	brne GRAFIC_LINIE_NO_VERTIKAL
	cp temp2,temp6	; X1 X2 (HIGH)	
	brne GRAFIC_LINIE_NO_VERTIKAL
	; Y2-Y1 negativ ?			
	sub temp7,temp3
	sbc temp8,temp4
	tst temp8
	brpl GRAFIC_LINIE_VERTIKAL_p	; positv	
	; negativ Y1-Y2 tauschen	
	LDS XL,(adr_GRAFIC_X1_L)		; X1		
	LDS XH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y2_L)		; Y2		
	LDS YH,(adr_GRAFIC_Y2_H)
	LDS ZL,(adr_GRAFIC_Y1_L)		; Y1 Schleife
	LDS ZH,(adr_GRAFIC_Y1_H)
	rjmp GRAFIC_LINIE_VERTIKAL_s
GRAFIC_LINIE_VERTIKAL_p:
	; positiv					
	LDS XL,(adr_GRAFIC_X1_L)		; X1		
	LDS XH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y1_L)		; Y1		
	LDS YH,(adr_GRAFIC_Y1_H)
	LDS ZL,(adr_GRAFIC_Y2_L)		; Y2 Schleife
	LDS ZH,(adr_GRAFIC_Y2_H)
	; SCHLEIFE					
GRAFIC_LINIE_VERTIKAL_s:
	adiw YL,1
	rcall GRAFIC_PUNKT_X_Y	; PUNKT	
	cp YL,ZL ;Schleife
	brne GRAFIC_LINIE_VERTIKAL_s
	cp YH,ZH ;Schleife
	brne GRAFIC_LINIE_VERTIKAL_s
	ret
GRAFIC_LINIE_NO_VERTIKAL:
; ##############################################################################
; ##############################################################################
; ##############################################################################
; schrge LINIEN																
	; SICHERUNGSKOPIE				
	STS(adr_GRAFIC_X1_LINIE_L),temp1	; X1
	STS(adr_GRAFIC_X1_LINIE_H),temp2
	STS(adr_GRAFIC_Y1_LINIE_L),temp3	; Y1
	STS(adr_GRAFIC_Y1_LINIE_H),temp4
	STS(adr_GRAFIC_X2_LINIE_L),temp5	; X2
	STS(adr_GRAFIC_X2_LINIE_H),temp6
	STS(adr_GRAFIC_Y2_LINIE_L),temp7	; Y2
	STS(adr_GRAFIC_Y2_LINIE_H),temp8
;-------------------------------------------------------------------------------	
GRAFIC_LINIE_CHECK:
	; DELTA X berchnen	(X2-X1)		
	LDS R0,(adr_GRAFIC_X1_LINIE_L)	; X1
	LDS R1,(adr_GRAFIC_X1_LINIE_H)
	LDS R2,(adr_GRAFIC_X2_LINIE_L)	; X2
	LDS R3,(adr_GRAFIC_X2_LINIE_H)
	sub R2,R0				; X2-X1		
	sbc R3,R1
	STS(adr_GRAFIC_LINIE_DELTA_X_L),R2	; Zwischenergebnis sichern	
	STS(adr_GRAFIC_LINIE_DELTA_X_H),R3
	; DELTA Y berchnen	(Y2-Y1)		
	LDS R0,(adr_GRAFIC_Y1_LINIE_L)	; Y1
	LDS R1,(adr_GRAFIC_Y1_LINIE_H)
	LDS R2,(adr_GRAFIC_Y2_LINIE_L)	; Y2
	LDS R3,(adr_GRAFIC_Y2_LINIE_H)
	sub R2,R0				; Y2-Y1		
	sbc R3,R1
	STS(adr_GRAFIC_LINIE_DELTA_Y_L),R2	; Zwischenergebnis sichern	
	STS(adr_GRAFIC_LINIE_DELTA_Y_H),R3
	; ist Linie stark fallend oder stark steigend ?	
	; BETRAG DELTA-Y minus BETRAG DELTA-X			
	LDS R0,(adr_GRAFIC_LINIE_DELTA_X_L)
	LDS R1,(adr_GRAFIC_LINIE_DELTA_X_H)
	SBRS R1,7	; Sprung bei negativ	
	rjmp GRAFIC_LINIE_CHECK_DX_OK
	com R0		; mal (-1)
	com R1
	add R0,EINS
	adc R1,NULL
GRAFIC_LINIE_CHECK_DX_OK:
	LDS R2,(adr_GRAFIC_LINIE_DELTA_Y_L)
	LDS R3,(adr_GRAFIC_LINIE_DELTA_Y_H)
	SBRS R3,7	; Sprung bei negativ	
	rjmp GRAFIC_LINIE_CHECK_DY_OK
	com R2		; mal (-1)
	com R3
	add R2,EINS
	adc R3,NULL
GRAFIC_LINIE_CHECK_DY_OK:
	sub R0,R2
	sbc R1,R3
	SBRC R1,7	; Sprung bei positiv	
	rjmp GRAFIC_LINIE_DY
;-------------------------------------------------------------------------------	
GRAFIC_LINIE_DX:
	; DELTA-X positiv ?					
	LDS temp,(adr_GRAFIC_LINIE_DELTA_X_H)
	tst temp
	brpl GRAFIC_LINIE_DX_OK
	; KOORDINATEN tauschen				
	STS(adr_GRAFIC_X2_LINIE_L),temp1	; X2
	STS(adr_GRAFIC_X2_LINIE_H),temp2
	STS(adr_GRAFIC_Y2_LINIE_L),temp3	; Y2
	STS(adr_GRAFIC_Y2_LINIE_H),temp4
	STS(adr_GRAFIC_X1_LINIE_L),temp5	; X1
	STS(adr_GRAFIC_X1_LINIE_H),temp6
	STS(adr_GRAFIC_Y1_LINIE_L),temp7	; Y2
	STS(adr_GRAFIC_Y1_LINIE_H),temp8
	rjmp GRAFIC_LINIE_CHECK
GRAFIC_LINIE_DX_OK:
	LDS R0,(adr_GRAFIC_LINIE_DELTA_Y_H)
	SBRC R0,7	; Sprung bei positiv	
	rjmp GRAFIC_LINIE_DX_DY_n
;-------------------------------------------------------------------------------	
; Eine LINIE entlang der X-Achse zeichnen, DELTA-Y ist positiv						
	; INITIALISIERUNG						
	LDS temp5,(adr_GRAFIC_LINIE_DELTA_X_L)	; DELTA-X (DIVISOR und SCHLEIFEN-BEGRENZUNG)
	LDS temp6,(adr_GRAFIC_LINIE_DELTA_X_H)	
	LDS XL,(adr_GRAFIC_X1_LINIE_L)			; X1		
	LDS XH,(adr_GRAFIC_X1_LINIE_H)
	LDS temp7,(adr_GRAFIC_Y1_LINIE_L)		; Y1		
	LDS temp8,(adr_GRAFIC_Y1_LINIE_H)
	clr ZL									; STEP		
	clr ZH
GRAFIC_LINIE_DX_DY_p_s:
	; DELTA-Y mal STEP(Z)
	LDS temp1,(adr_GRAFIC_LINIE_DELTA_Y_L)	; DELTA-Y	
	LDS temp2,(adr_GRAFIC_LINIE_DELTA_Y_H)
	mov temp3,ZL							; STEP(Z)	
	mov temp4,ZH
	call FUNKTION_MULTIPLIKATION_16_16_32
	; durch DELTA-X		
	call FUNCTION_DIVISION_32_16 			; temp1..4 (DIVIDENT) temp5+6 (DIVISOR)	
	mov YL,temp1
	mov YH,temp2
	; Y1 ADDIEREN		
	add YL,temp7							; Y1		
	adc YH,temp8
	rcall GRAFIC_PUNKT_X_Y					; PUNKT		
	ADIW XL,1								; X+1		
	; STEP-SCHLEIFE		
	ADIW ZL,1								; STEP+1 (Z+1)
	cp ZH,temp6	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DX_DY_p_s
	cp ZL,temp5	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DX_DY_p_s
	ret
;-------------------------------------------------------------------------------	
; Eine LINIE entlang der X-Achse zeichnen, DELTA-Y ist negativ						
GRAFIC_LINIE_DX_DY_n:
	; DELTA-Y invertieren					
	LDS temp1,(adr_GRAFIC_LINIE_DELTA_Y_L)	; DELTA-Y	
	LDS temp2,(adr_GRAFIC_LINIE_DELTA_Y_H)
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	STS(adr_GRAFIC_LINIE_DELTA_Y_L),temp1
	STS(adr_GRAFIC_LINIE_DELTA_Y_H),temp2
	; INITIALISIERUNG						
	LDS temp5,(adr_GRAFIC_LINIE_DELTA_X_L)	; DELTA-X (DIVISOR und SCHLEIFEN-BEGRENZUNG)
	LDS temp6,(adr_GRAFIC_LINIE_DELTA_X_H)	
	LDS XL,(adr_GRAFIC_X1_LINIE_L)			; X1		
	LDS XH,(adr_GRAFIC_X1_LINIE_H)
	LDS temp7,(adr_GRAFIC_Y1_LINIE_L)		; Y1		
	LDS temp8,(adr_GRAFIC_Y1_LINIE_H)
	clr ZL									; STEP		
	clr ZH
GRAFIC_LINIE_DX_DY_n_s:
	; DELTA-Y mal STEP(Z)
	LDS temp1,(adr_GRAFIC_LINIE_DELTA_Y_L)	; DELTA-Y	
	LDS temp2,(adr_GRAFIC_LINIE_DELTA_Y_H)
	mov temp3,ZL							; STEP(Z)	
	mov temp4,ZH
	call FUNKTION_MULTIPLIKATION_16_16_32
	; durch DELTA-X		
	call FUNCTION_DIVISION_32_16 			; temp1..4 (DIVIDENT) temp5+6 (DIVISOR)	
	mov YL,temp1
	mov YH,temp2
	; Mal (-1)			
	com YL
	com YH
	add YL,EINS
	adc YH,NULL
	; Y1 ADDIEREN		
	add YL,temp7							; Y1		
	adc YH,temp8
	rcall GRAFIC_PUNKT_X_Y					; PUNKT		
	ADIW XL,1								; X+1		
	; STEP-SCHLEIFE		
	ADIW ZL,1								; STEP+1 (Z+1)
	cp ZH,temp6	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DX_DY_n_s
	cp ZL,temp5	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DX_DY_n_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GRAFIC_LINIE_DY:
	; DELTA-X positiv ?					
	LDS temp,(adr_GRAFIC_LINIE_DELTA_Y_H)
	tst temp
	brpl GRAFIC_LINIE_DY_OK
	; KOORDINATEN tauschen				
	STS(adr_GRAFIC_X2_LINIE_L),temp1	; X2
	STS(adr_GRAFIC_X2_LINIE_H),temp2
	STS(adr_GRAFIC_Y2_LINIE_L),temp3	; Y2
	STS(adr_GRAFIC_Y2_LINIE_H),temp4
	STS(adr_GRAFIC_X1_LINIE_L),temp5	; X1
	STS(adr_GRAFIC_X1_LINIE_H),temp6
	STS(adr_GRAFIC_Y1_LINIE_L),temp7	; Y2
	STS(adr_GRAFIC_Y1_LINIE_H),temp8
	rjmp GRAFIC_LINIE_CHECK
GRAFIC_LINIE_DY_OK:
	LDS R0,(adr_GRAFIC_LINIE_DELTA_X_H)
	SBRC R0,7	; Sprung bei positiv	
	rjmp GRAFIC_LINIE_DY_DX_n
;-------------------------------------------------------------------------------	
; Eine LINIE entlang der Y-Achse zeichnen, DELTA-X ist positiv						
	; INITIALISIERUNG						
	LDS temp5,(adr_GRAFIC_LINIE_DELTA_Y_L)	; DELTA-Y (DIVISOR und SCHLEIFEN-BEGRENZUNG)
	LDS temp6,(adr_GRAFIC_LINIE_DELTA_Y_H)	
	LDS YL,(adr_GRAFIC_Y1_LINIE_L)			; Y1		
	LDS YH,(adr_GRAFIC_Y1_LINIE_H)
	LDS temp7,(adr_GRAFIC_X1_LINIE_L)		; X1		
	LDS temp8,(adr_GRAFIC_X1_LINIE_H)
	clr ZL									; STEP		
	clr ZH
GRAFIC_LINIE_DY_DX_p_s:
	; DELTA-X mal STEP(Z)
	LDS temp1,(adr_GRAFIC_LINIE_DELTA_X_L)	; DELTA-X	
	LDS temp2,(adr_GRAFIC_LINIE_DELTA_X_H)
	mov temp3,ZL							; STEP(Z)	
	mov temp4,ZH
	call FUNKTION_MULTIPLIKATION_16_16_32
	; durch DELTA-Y		
	call FUNCTION_DIVISION_32_16 			; temp1..4 (DIVIDENT) temp5+6 (DIVISOR)	
	mov XL,temp1
	mov XH,temp2
	; X1 ADDIEREN		
	add XL,temp7							; X1		
	adc XH,temp8
	rcall GRAFIC_PUNKT_X_Y					; PUNKT		
	ADIW YL,1								; Y+1		
	; STEP-SCHLEIFE		
	ADIW ZL,1								; STEP+1 (Z+1)
	cp ZH,temp6	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DY_DX_p_s
	cp ZL,temp5	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DY_DX_p_s
	ret
;-------------------------------------------------------------------------------	
; Eine LINIE entlang der Y-Achse zeichnen, DELTA-X ist negativ						
GRAFIC_LINIE_DY_DX_n:
	; DELTA-X invertieren					
	LDS temp1,(adr_GRAFIC_LINIE_DELTA_X_L)	; DELTA-X	
	LDS temp2,(adr_GRAFIC_LINIE_DELTA_X_H)
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	STS(adr_GRAFIC_LINIE_DELTA_X_L),temp1
	STS(adr_GRAFIC_LINIE_DELTA_X_H),temp2
	; INITIALISIERUNG						
	LDS temp5,(adr_GRAFIC_LINIE_DELTA_Y_L)	; DELTA-Y (DIVISOR und SCHLEIFEN-BEGRENZUNG)
	LDS temp6,(adr_GRAFIC_LINIE_DELTA_Y_H)	
	LDS YL,(adr_GRAFIC_Y1_LINIE_L)			; Y1		
	LDS YH,(adr_GRAFIC_Y1_LINIE_H)
	LDS temp7,(adr_GRAFIC_X1_LINIE_L)		; X1		
	LDS temp8,(adr_GRAFIC_X1_LINIE_H)
	clr ZL									; STEP		
	clr ZH
GRAFIC_LINIE_DY_DX_n_s:
	; DELTA-X mal STEP(Z)
	LDS temp1,(adr_GRAFIC_LINIE_DELTA_X_L)	; DELTA-X	
	LDS temp2,(adr_GRAFIC_LINIE_DELTA_X_H)
	mov temp3,ZL							; STEP(Z)	
	mov temp4,ZH
	call FUNKTION_MULTIPLIKATION_16_16_32
	; durch DELTA-Y		
	call FUNCTION_DIVISION_32_16 			; temp1..4 (DIVIDENT) temp5+6 (DIVISOR)	
	mov XL,temp1
	mov XH,temp2
	; Mal (-1)			
	com XL
	com XH
	add XL,EINS
	adc XH,NULL
	; X1 ADDIEREN		
	add XL,temp7							; X1		
	adc XH,temp8
	rcall GRAFIC_PUNKT_X_Y					; PUNKT		
	ADIW YL,1								; Y+1		
	; STEP-SCHLEIFE		
	ADIW ZL,1								; STEP+1 (Z+1)
	cp ZH,temp6	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DY_DX_n_s
	cp ZL,temp5	; (STEP-BEGRENZUNG)
	brne GRAFIC_LINIE_DY_DX_n_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;			(adr_GRAFIC_X1_L)													
;			(adr_GRAFIC_X1_H)													
;			(adr_GRAFIC_Y1_L)													
;			(adr_GRAFIC_Y1_H)													
;			(adr_GRAFIC_X2_L)													
;			(adr_GRAFIC_X2_H)													
;			(adr_GRAFIC_Y2_L)													
;			(adr_GRAFIC_Y2_H)													
;																				
;																				
; Zeichnet ein Rechteck an den KOORDINATEN (X1,Y1) (X2,Y2)						
;																				
GRAFIC_RECHTECK:
	; SICHERUNGSKOPIE						
	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	STS(adr_GRAFIC_X1_KOPIE_L),XL
	STS(adr_GRAFIC_X1_KOPIE_H),XH
	STS(adr_GRAFIC_Y1_KOPIE_L),YL
	STS(adr_GRAFIC_Y1_KOPIE_H),YH
	LDS XL,(adr_GRAFIC_X2_L)
	LDS XH,(adr_GRAFIC_X2_H)
	LDS YL,(adr_GRAFIC_Y2_L)
	LDS YH,(adr_GRAFIC_Y2_H)
	STS(adr_GRAFIC_X2_KOPIE_L),XL
	STS(adr_GRAFIC_X2_KOPIE_H),XH
	STS(adr_GRAFIC_Y2_KOPIE_L),YL
	STS(adr_GRAFIC_Y2_KOPIE_H),YH
	; vertical-links (X1/Y1)(X1/Y2)			
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)		; X1 (temp1+2)	
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)		; Y1 (temp3+4)	
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)		; Y2 (temp7+8)	
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp1	; X2		
	STS(adr_GRAFIC_X2_H),temp2
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; horizontal-unten (X1/Y1)(X2/Y1)		
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)		; X1 (temp1+2)	
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)		; Y1 (temp3+4)	
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)		; X2 (temp5+6)	
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp3	; Y2		
	STS(adr_GRAFIC_Y2_H),temp4
	rcall GRAFIC_LINIE	
	; vertikal-rechts (X2/Y1)(X2/Y2)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)		; Y1 (temp3+4)	
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)		; X2 (temp5+6)	
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)		; Y2 (temp7+8)	
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp5	; X1		
	STS(adr_GRAFIC_X1_H),temp6
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; horizontal-oben (X2/Y2)(X1/Y2)
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)		; X1 (temp1+2)	
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)		; X2 (temp5+6)	
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)		; Y2 (temp7+8)	
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp5	; X1		
	STS(adr_GRAFIC_X1_H),temp6
	STS(adr_GRAFIC_Y1_L),temp7	; Y1		
	STS(adr_GRAFIC_Y1_H),temp8
	STS(adr_GRAFIC_X2_L),temp1	; X2		
	STS(adr_GRAFIC_X2_H),temp2
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; wieder herstellen			
	LDS XL,(adr_GRAFIC_X1_KOPIE_L)
	LDS XH,(adr_GRAFIC_X1_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y1_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y1_KOPIE_H)
	STS(adr_GRAFIC_X1_L),XL
	STS(adr_GRAFIC_X1_H),XH
	STS(adr_GRAFIC_Y1_L),YL
	STS(adr_GRAFIC_Y1_H),YH
	LDS XL,(adr_GRAFIC_X2_KOPIE_L)
	LDS XH,(adr_GRAFIC_X2_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y2_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X2_L),XL
	STS(adr_GRAFIC_X2_H),XH
	STS(adr_GRAFIC_Y2_L),YL
	STS(adr_GRAFIC_Y2_H),YH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;			(adr_GRAFIC_X1_L)													
;			(adr_GRAFIC_X1_H)													
;			(adr_GRAFIC_Y1_L)													
;			(adr_GRAFIC_Y1_H)													
;			(adr_GRAFIC_X2_L)													
;			(adr_GRAFIC_X2_H)													
;			(adr_GRAFIC_Y2_L)													
;			(adr_GRAFIC_Y2_H)													
;			(adr_GRAFIC_X3_L)													
;			(adr_GRAFIC_X3_H)													
;			(adr_GRAFIC_Y3_L)													
;			(adr_GRAFIC_Y3_H)													
;																				
; Zeichnet ein DREIECK an den KOORDINATEN (X1,Y1)(X2,Y2)(X3,Y3)					
;																				
GRAFIC_DREIECK:
	; SICHERUNGSKOPIE						
	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	STS(adr_GRAFIC_X1_KOPIE_L),XL
	STS(adr_GRAFIC_X1_KOPIE_H),XH
	STS(adr_GRAFIC_Y1_KOPIE_L),YL
	STS(adr_GRAFIC_Y1_KOPIE_H),YH
	LDS XL,(adr_GRAFIC_X2_L)
	LDS XH,(adr_GRAFIC_X2_H)
	LDS YL,(adr_GRAFIC_Y2_L)
	LDS YH,(adr_GRAFIC_Y2_H)
	STS(adr_GRAFIC_X2_KOPIE_L),XL
	STS(adr_GRAFIC_X2_KOPIE_H),XH
	STS(adr_GRAFIC_Y2_KOPIE_L),YL
	STS(adr_GRAFIC_Y2_KOPIE_H),YH
	LDS XL,(adr_GRAFIC_X3_L)
	LDS XH,(adr_GRAFIC_X3_H)
	LDS YL,(adr_GRAFIC_Y3_L)
	LDS YH,(adr_GRAFIC_Y3_H)
	STS(adr_GRAFIC_X3_KOPIE_L),XL
	STS(adr_GRAFIC_X3_KOPIE_H),XH
	STS(adr_GRAFIC_Y3_KOPIE_L),YL
	STS(adr_GRAFIC_Y3_KOPIE_H),YH
	; 1.LINIE (X1,Y1)(X2,Y2)				
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; 2.LINIE (X2,Y2)(X3,Y3)				
	LDS temp1,(adr_GRAFIC_X2_KOPIE_L)
	LDS temp2,(adr_GRAFIC_X2_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y2_KOPIE_L)
	LDS temp4,(adr_GRAFIC_Y2_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X3_KOPIE_L)
	LDS temp6,(adr_GRAFIC_X3_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y3_KOPIE_L)
	LDS temp8,(adr_GRAFIC_Y3_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE
	; 3.LINIE (X3,Y3)(X1,Y1)				
	LDS temp1,(adr_GRAFIC_X3_KOPIE_L)
	LDS temp2,(adr_GRAFIC_X3_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y3_KOPIE_L)
	LDS temp4,(adr_GRAFIC_Y3_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X1_KOPIE_L)
	LDS temp6,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y1_KOPIE_L)
	LDS temp8,(adr_GRAFIC_Y1_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE
	; wieder herstellen			
	LDS XL,(adr_GRAFIC_X1_KOPIE_L)
	LDS XH,(adr_GRAFIC_X1_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y1_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y1_KOPIE_H)
	STS(adr_GRAFIC_X1_L),XL
	STS(adr_GRAFIC_X1_H),XH
	STS(adr_GRAFIC_Y1_L),YL
	STS(adr_GRAFIC_Y1_H),YH
	LDS XL,(adr_GRAFIC_X2_KOPIE_L)
	LDS XH,(adr_GRAFIC_X2_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y2_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X2_L),XL
	STS(adr_GRAFIC_X2_H),XH
	STS(adr_GRAFIC_Y2_L),YL
	STS(adr_GRAFIC_Y2_H),YH
	LDS XL,(adr_GRAFIC_X3_KOPIE_L)
	LDS XH,(adr_GRAFIC_X3_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y3_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y3_KOPIE_H)
	STS(adr_GRAFIC_X3_L),XL
	STS(adr_GRAFIC_X3_H),XH
	STS(adr_GRAFIC_Y3_L),YL
	STS(adr_GRAFIC_Y3_H),YH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;		(adr_GRAFIC_X1_L)														
;		(adr_GRAFIC_X1_H)														
;		(adr_GRAFIC_Y1_L)														
;		(adr_GRAFIC_Y1_H)														
;		(adr_GRAFIC_LAENGE_L)													
;		(adr_GRAFIC_LAENGE_H)													
;		(adr_GRAFIC_WINKEL_L)													
;		(adr_GRAFIC_WINKEL_H)													
;																				
; Zeichnet einen Zeiger vom Punkt X,Y im Winkel und Lnge						
;																				
GRAFIC_ZEIGER:
	; (X)SINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_SINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_SINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal LNGE						
	LDS temp3,(adr_GRAFIC_LAENGE_L)
	LDS temp4,(adr_GRAFIC_LAENGE_H)
 	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_X_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_X_DIV
GRAFIC_ZEIGER_X_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_X_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	

	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	add temp1,XL
	adc temp2,XH
	STS(adr_GRAFIC_X2_L),temp1
	STS(adr_GRAFIC_X2_H),temp2
	;---------------------------------------------------
	; (Y) COSINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_COSINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_COSINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal LNGE						
	LDS temp3,(adr_GRAFIC_LAENGE_L)
	LDS temp4,(adr_GRAFIC_LAENGE_H)
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_Y_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_Y_DIV
GRAFIC_ZEIGER_Y_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_Y_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	

	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	add temp1,YL
	adc temp2,YH
	STS(adr_GRAFIC_Y2_L),temp1
	STS(adr_GRAFIC_Y2_H),temp2
	rjmp GRAFIC_LINIE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;		(adr_GRAFIC_X1_L)														
;		(adr_GRAFIC_X1_H)														
;		(adr_GRAFIC_Y1_L)														
;		(adr_GRAFIC_Y1_H)														
;		(adr_GRAFIC_WINKEL_L)													
;		(adr_GRAFIC_WINKEL_H)													
;		(adr_GRAFIC_KREIS_RADIUS)												
;																				
; Zeichnet einen PUNKT vom Punkt X,Y im Winkel									
;																				
GRAFIC_ZEIGER_PUNKT:
	; (X)SINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_SINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_SINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal RADIUS						
	LDS temp3,(adr_GRAFIC_KREIS_RADIUS)
	clr temp4
 	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_PUNKT_X_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_PUNKT_X_DIV
GRAFIC_ZEIGER_PUNKT_X_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_PUNKT_X_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	
	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	add XL,temp1
	adc XH,temp2
	;---------------------------------------------------
	; (Y) COSINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_COSINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_COSINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal RADIUS						
	LDS temp3,(adr_GRAFIC_KREIS_RADIUS)
	clr temp4
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_PUNKT_Y_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_PUNKT_Y_DIV
GRAFIC_ZEIGER_PUNKT_Y_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_PUNKT_Y_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	

	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	add YL,temp1
	adc YH,temp2

	rcall GRAFIC_PUNKT_X_Y

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
